﻿<template>
  <div>
    <div class="d-flex add col-4">
      <v-input placeholder="New todo" v-model="txtName"/>
      <v-button class="btn" type="submit" lg primary @click="addTodo">Add</v-button>
    </div>
    <TodoItem v-for="(todo,idx) in arr" :key="idx" :todoProps="todo" @updateComp="changeProps" @deleteItem="delItem"/>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import {Component, Prop, Watch} from 'vue-property-decorator';
import {client} from '../../shared';
import {Hello} from '../../shared/dtos';
import {TodoItem} from "@/components/Home/TodoItem.vue";
import axios from "axios";

@Component({
  components: {
    TodoItem
  },
})
export class Todos extends Vue {
  @Prop() public name: string;
  public txtName: string = '';
  public result: string = '';
  public arr: any = [];
  public id: any = 1;

  public mounted() {
    this.getAllToDos();
  }

  async getAllToDos() {
    try {
      const res = await axios.get(
          'https://jsonplaceholder.typicode.com/todos?_limit=5'
      )
      this.arr = res.data;
      console.log(this.arr)
    } catch (err) {
      console.log(err)
    }
  }

  async addTodo() {
    var obj = {
      title: this.txtName,
      complete: false
    };
    try {
      const res = await axios.post(
          'https://jsonplaceholder.typicode.com/todos',
          obj
      )
      this.arr.push(res.data)
      this.txtName = '';
    } catch (error) {
      console.log(error)
    }
  }

  changeProps(id: any) {
    this.arr = this.arr.map((todo: any) => {
      if (todo.id === id) {
        todo.completed = !todo.completed;
      }
      return todo;
    })
  }

  async delItem(id: any) {
    try {
      await axios.delete(`https://jsonplaceholder.typicode.com/todos/${id}`);
      this.arr = this.arr.filter((x: any) => x.id !== id);
    } catch (e) {
      console.log(e)
    }
  }
}

export default Todos;
</script>

<style>
.result {
  color: #41B883;
}

.add {
  margin-bottom: 10px;
}

.btn {
  margin-left: 5px;
}

</style>